;;
;;  Miscellaneous functions
;;


;; Here is a simple sorting function.  Set a mark at the top left corner of 
;; region to be sorted, then move to lower right corner to define a rectangle.
;; The execute the command 'bsort'.  

(
   [end beg last this f_sw chg col ecol now]
   markp { "set mark!" error } !if
   
   whatline =end what_column =ecol
   "exchange" call whatline =beg
   what_column =col
  
   "transpose_lines" =f_sw
   
   1 {
     pop
     0 =chg
     beg goto_line bol col goto_column
     push_mark
     ecol goto_column bufsubstr =last
     beg 1 + end 1
     {
       goto_line
       col goto_column
       push_mark
       ecol goto_column bufsubstr =this
       last this strcmp 0 > 
       { f_sw call 1 =chg}{this =last } else
     } for  
     end 1 - =end   ;; since highest gets put at end.
     update
     chg
   } while
  "Done." message
) bsort

;; Since this version of JED uses Linked-List approach and does not
;; support regular expressions, it is hard to search for strings at the 
;; beginning or end of a line.  Here are some functions which do this:

(           ;; bol_fsearch  returns 0 if not found
  [s] =s    ;; sample usage:  push_spot "string" bol_fsearch
            ;;                {pop_spot} !if
  1 { down 
        {bol s looking_at {1 0}{1} else }
	{0 0} else
    } while
) bol_fsearch

;;
;;  atrim:  trims all whitespace around point
;;
( trim
  eolp {
        bolp { 1 left pop 
               what_column trim what_column -
	       {1 right pop } !if
	     }
	 !if
       }
  !if
) atrim



;;
;;  A common problem:  I like 4 column tabs but my printer insists on 8
;;		       column tabs.  How do I keep 8 column tabs but make
;;		       the tab key simulate 4 column tabs?
;;  Solution:

8 =TAB               ;; tabs set at 8 characters
[MYTAB] 4 =MYTAB     ;; a new global variable

( [c goal] what_column =c
  c 1 -
  MYTAB / 1 +
  MYTAB * 1 + =goal
  goal c - whitespace
  ;;
  ;; Now fixup any multiple spaces. Not needed but reduces file size.
  ;;
  skip_white what_column 
  atrim
  what_column - whitespace
  goal goto_column
) my_tab_cmd      "my_tab_cmd"  "^I" setkey  ;; function bound to tab key

(
   [ch]  "}" =ch

   ch insert
   indent_line
   1 left pop del
   update
   ch int =LAST_CHAR self_ins
   "\n\n" insert indent_line
) my_ket_cmd "my_ket_cmd" "}" setkey

   
