;;
;;  Site specific initialiation file.
;;  Should be placed in the JED_LIBRARY directory.
;;

;; A useful hooks function---
;; There is a builtin one in slang as well that is called from C code
( [hook_fun] =hook_fun
  hook_fun defined? { hook_fun eval } if
) runhooks

;; a help command:  if help is in jed.rc then this gets called
("help.sl" evalfile ) help


;; These commands are better off in the jed.rc (.jedrc) file:
;; this next command changes to emacs keybindings:
;; "emacs.sl" evalfile

;; For other popular editors:  
;;  "edt.sl" evalfile
;;  "wordstar.sl" evalfile    ;; does not exist yet
;;  etc...


;; define a fortran macro to load fortran.sl
(
   [f] "Fortran" =f
   "Fortran_Mode" defined?
      {1} { "fortran.sl" evalfile }
      else { f use_keymap
             f setmode
	   } if
) fortran

(
   "DCL_Mode" defined? 
      {1} { "dcl.sl" evalfile } else
      {"DCL" use_keymap
       "dcl" setmode } if
) dcl

;;; scroll other window macros-- bind them yourself
( nwindows 1 -
  otherwindow
  pageup
  { otherwindow } loop
) next_wind_up  
;; "next_wind_up"  "^W^[[A"  setkey
  
( nwindows 1 -
  otherwindow
  pagedown
  { otherwindow } loop
) next_wind_dn  "next_wind_dn"  
;;"^W^[[B"  setkey




;; some file hooks

(
   [type] =type
   
   {type "c"     strcmp {0}{"cmode" setmode 1} else}
   {type "h"     strcmp {0}{"cmode" setmode 1} else}
   {type "tex"   strcmp {0}{"wrap" setmode 1} else}
   {type "txt"   strcmp {0}{"wrap" setmode 1} else}
   {type "doc"   strcmp {0}{"wrap" setmode 1} else}
   {type "f"     strcmp {0}{fortran 1} else}
   {type "for"   strcmp {0}{fortran 1} else}
   {type "com"   strcmp {0}{"_VMS" defined? {dcl 1}{0} else} else}
   {"nomode" setmode 0}
   orelse pop
) mode_hook
 
;; sort function
;; Slang programmers note the trick here for autoloading

() sort 
("sort.sl" evalfile sort) sort

() untab
( "untab.sl" evalfile untab ) untab

;; apropos function

( [n l dl cbuf]

  "apropos:" "" read_mini
  slapropos =n n 5 / =l n l 5 * - =dl
  
  whatbuf =cbuf
  "*apropos*" pop2buf erase_buffer
  l { 
      0 4 1 { 14 * 1 + goto_column insert } for
      "\n" insert
    } loop
  0 dl 1 - 1 { 14 * 1 + goto_column insert} for
  bob
  cbuf pop2buf
) apropos

;;
;; most hook
;;


( "Most" defined? { "most.sl" evalfile } !if
  "most" setmode
  "Most_Map" use_keymap
  "'Q' quits MOST file viewing mode." message
) most

( "( pop most ) mode_hook" eval ) do_most


;; occur function
;;
(
  [str cbuf tmp]  ;; local variables
  "Find All:" "" read_mini =str
  "*occur*" =tmp whatbuf =cbuf
  tmp bufferp { tmp delbuf } if
  push_spot
  str fsearch
    {
       pop             ;; while puts loop variable on stack
       whatline string 
       push_mark
       narrow
       tmp setbuf
       insert 5 goto_column ":"  insert
       cbuf insbuf "\n" insert
       cbuf setbuf
       widen
       eol             ;; so we do not find another occurance on same line
       str fsearch
    } while
    pop_spot
    ;; did we make it
    tmp bufferp { tmp pop2buf bob } if
 ) occur 


( "Line:" whatline string strcat
  " Column:" what_column string strcat strcat message ) whatpos
  
  "whatpos" "^X?" setkey
  
"_IBMPC" defined? 
  { "showkey" "^HC" setkey 
    "apropos" "^HA" setkey
  } !if
  
  


