/*
 *  Copyright (c) 1992 John E. Davis  (davis@amy.tch.harvard.edu)
 *  All Rights Reserved.
 */
#ifndef __DAVIS_SYSDEP_H__
#define __DAVIS_SYSDEP_H__

#include <stdio.h>
extern volatile int KeyBoard_Quit;
extern volatile int Lang_Error;

extern int INPUT_BUFFER_LEN;
extern char INPUT_BUFFER[255];

extern char (*sys_getkey_ptr)(void);
extern char sys_getkey(void);

extern void init_tty(void);
extern void reset_tty(void);
extern char getkey(void);
extern int input_pending(int, int);
extern void flush_input(void);
extern void ungetkey(char);
extern void sys_resume(void);
extern void get_term_dimensions(int *, int *);
extern int sys_delete_file(char *);
extern int sys_chmod(char *, int, int *);

/* expand the file in a canonical way and return a pointer to the file name
   not the directory.  That is, if file is /tmp/foo/bar then return pointer to 
   bar */
extern char *expand_filename(char *);

extern int sys_findfirst(char *);
extern int sys_findnext(char *);

extern char *get_time(void);
extern int Screen_Height;
extern int Screen_Width;


#ifdef msdos
#define SCREEN_HEIGHT 25
#else
#define SCREEN_HEIGHT 24
#endif

#endif /* __DAVIS_SYSDEP_H__ */
